<?php
/**
 * Created by PhpStorm.
 * User: RSkaldin
 * Date: 6/3/2019
 * Time: 1:04 AM
 */

namespace App\Http\Controllers\Postman;

use App\Http\Controllers\Controller;
use App\Models\Activity;
use App\Models\Address;
use Illuminate\Http\Request;

class AddressController extends Controller {

    /**
     * List of available addresses
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function index()
    {
        $addresses = Address::orderBy('id', 'DESC')->paginate(25);
        return view('pages.admin.address.address_list', ['addresses' => $addresses]);
    }

    /**
     * View edit user's address
     * @param $address_id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function edit($address_id)
    {
        return view('pages.admin.address.edit', ['address' => Address::find($address_id)]);
    }

    /**
     * Update address information
     * @param $address_id
     * @param Request $request
     * @return \Illuminate\Http\RedirectResponse
     */
    public function update($address_id, Request $request)
    {
        try {
            if (($address = Address::find($address_id)) == null)
                throw new \Exception('Address not found');

            $address->fill($request->all());
            $address->update();
        } catch (\Exception $ex) {
            Activity::appendLog("Ошибка обновления информации об адресе: ".$ex->getMessage(), Activity::ERROR);
            return redirect()->back()->with(['error' => $ex->getMessage()]);
        }

        Activity::appendLog("Информация об адресе обновлена успешно", Activity::SUCCESS);
        return redirect()->back()->with(['success' => 'Информация обновлена успешно.']);
    }

}